package org.jeecg.modules.database.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.database.entity.Equipment;
import org.jeecg.modules.database.service.IEquipmentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DuplicateKeyException;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import java.util.Arrays;

/**
 * @Description: 设备
 * @Author: jeecg-boot
 * @Date: 2024-08-30
 * @Version: V1.0
 */
@Tag(name = "设备")
@RestController
@RequestMapping("/database/equipment")
@Slf4j
public class EquipmentController extends JeecgController<Equipment, IEquipmentService> {
    @Autowired
    private IEquipmentService equipmentService;

    /**
     * 分页列表查询
     *
     * @param equipment
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    //@AutoLog(value = "设备-分页列表查询")
    @Operation(summary = "设备-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<Equipment>> queryPageList(Equipment equipment,
                                                  @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                  @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                  HttpServletRequest req) {
        QueryWrapper<Equipment> queryWrapper = QueryGenerator.initQueryWrapper(equipment, req.getParameterMap());
        Page<Equipment> page = new Page<Equipment>(pageNo, pageSize);
        IPage<Equipment> pageList = equipmentService.page(page, queryWrapper);
        return Result.OK(pageList);
    }

    /**
     * 添加
     *
     * @param equipment
     * @return
     */
    @AutoLog(value = "设备-添加")
    @Operation(summary = "设备-添加")
    @RequiresPermissions("database:equipment:add")
    @PostMapping(value = "/add")
    public Result<String> add(@RequestBody Equipment equipment) {
        try {
            equipmentService.save(equipment);
        } catch (DuplicateKeyException e) {
            return Result.error("设备已存在！");
        } catch (Exception e) {
            return Result.error("添加成失败！");
        }
        return Result.OK("添加成功！");
    }

    /**
     * 编辑
     *
     * @param equipment
     * @return
     */
    @AutoLog(value = "设备-编辑")
    @Operation(summary = "设备-编辑")
    @RequiresPermissions("database:equipment:edit")
    @RequestMapping(value = "/edit", method = {RequestMethod.PUT, RequestMethod.POST})
    public Result<String> edit(@RequestBody Equipment equipment) {
        equipmentService.updateById(equipment);
        return Result.OK("编辑成功!");
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "设备-通过id删除")
    @Operation(summary = "设备-通过id删除")
    @RequiresPermissions("database:equipment:delete")
    @DeleteMapping(value = "/delete")
    public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
        equipmentService.removeById(id);
        return Result.OK("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "设备-批量删除")
    @Operation(summary = "设备-批量删除")
    @RequiresPermissions("database:equipment:delete")
    @DeleteMapping(value = "/deleteBatch")
    public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        this.equipmentService.removeByIds(Arrays.asList(ids.split(",")));
        return Result.OK("批量删除成功!");
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    //@AutoLog(value = "设备-通过id查询")
    @Operation(summary = "设备-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<Equipment> queryById(@RequestParam(name = "id", required = true) String id) {
        Equipment equipment = equipmentService.getById(id);
        if (equipment == null) {
            return Result.error("未找到对应数据");
        }
        return Result.OK(equipment);
    }

    /**
     * 导出excel
     *
     * @param request
     * @param equipment
     */

    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Equipment equipment) {
        return super.exportXls(request, equipment, Equipment.class, "设备");
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequiresPermissions("database:equipment:add")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Equipment.class);
    }

}
